file.txt

```
1： <ZWAXJGDLUBVIQHKYPNTCRMOSFE <
2： <KPBELNACZDTRXMJQOYHGVSFUWI <
3： <BDMAIZVRNSJUWFHTEQGYXPLOCK <
4： <RPLNDVHGFCUKTEBSXQYIZMJWAO <
5： <IHFRLABEUOTSGJVDKCPMNZQWXY <
6： <AMKGHIWPNYCJBFZDRUSLOQXVET <
7： <GWTHSPYBXIZULVKMRAFDCEONJQ <
8： <NOZUTWDCVRJLXKISEFAPMYGHBQ <
9： <QWATDSRFHENYVUBMCOIKZGJXPL <
10： <WABMCXPLTDSRJQZGOIKFHENYVU <
11： <XPLTDAOIKFZGHENYSRUBMCQWVJ <
12： <TDSWAYXPLVUBOIKZGJRFHENMCQ <
13： <BMCSRFHLTDENQWAOXPYVUIKZGJ <
14： <XPHKZGJTDSENYVUBMLAOIRFCQW <

密钥： 2,5,1,3,6,4,9,7,8,14,10,13,11,12

密文：HCBTSXWCRQGLES
```

## 这是一种加密方式，叫做轮转密码或者叫比尔密码

解密的方式就是先通过密钥调整字符串的行号，然后通过密文调整每一行字符串的顺序

第一行字符串是

```python
KPBELNACZDTRXMJQOYHGVSFUWI
```

则，将H 以前的所有字符放到该字符串的末尾

```python
HGVSFUWIKPBELNACZDTRXMJQOY
```

## 整理file.txt

```
ZWAXJGDLUBVIQHKYPNTCRMOSFE 
KPBELNACZDTRXMJQOYHGVSFUWI 
BDMAIZVRNSJUWFHTEQGYXPLOCK 
RPLNDVHGFCUKTEBSXQYIZMJWAO 
IHFRLABEUOTSGJVDKCPMNZQWXY 
AMKGHIWPNYCJBFZDRUSLOQXVET 
GWTHSPYBXIZULVKMRAFDCEONJQ 
NOZUTWDCVRJLXKISEFAPMYGHBQ 
QWATDSRFHENYVUBMCOIKZGJXPL 
WABMCXPLTDSRJQZGOIKFHENYVU 
XPLTDAOIKFZGHENYSRUBMCQWVJ 
TDSWAYXPLVUBOIKZGJRFHENMCQ 
BMCSRFHLTDENQWAOXPYVUIKZGJ 
XPHKZGJTDSENYVUBMLAOIRFCQW 
```

## 脚本

```
#coding:utf-8
#秘钥
key="2,5,1,3,6,4,9,7,8,14,10,13,11,12"
#密文
cipher_text = "HCBTSXWCRQGLES"

f = open("file.txt")
str_first_encry = []

for line in f:  # 读取file.txt每一行到数组
    line = line.strip()
    str_first_encry.append(line)


key_index = key.split(",")  #根据数组和编号排序
str_second_encry = []
for k in key_index:
    str_second_encry.append(str_first_encry[int(k)-1])
    # print(str_first_encry[int(k)-1])


for i,ch in enumerate(cipher_text):
    line = str_second_encry[i]
    split_index = line.index(ch)
    temp=[]
    temp[0:len(line)-split_index+1] = line[split_index:len(line)]  #巧妙分割
    temp[len(temp):] = line[0:split_index]
    str_second_encry[i] = "".join(temp)

# for plain in str_second_encry:    #变换后的数组
#     print(plain)

for i in range(14):
    str = str_second_encry[i][-6]
    print(str.lower(),end='')
    
```

## 结果

```
 KPBELNACZDTRXMJQOYHGVSFUWI
 IHFRLABEUOTSGJVDKCPMNZQWXY
 ZWAXJGDLUBVIQHKYPNTCRMOSFE
 BDMAIZVRNSJUWFHTEQGYXPLOCK
 AMKGHIWPNYCJBFZDRUSLOQXVET
 RPLNDVHGFCUKTEBSXQYIZMJWAO
 QWATDSRFHENYVUBMCOIKZGJXPL
 GWTHSPYBXIZULVKMRAFDCEONJQ
 NOZUTWDCVRJLXKISEFAPMYGHBQ
 XPHKZGJTDSENYVUBMLAOIRFCQW
 WABMCXPLTDSRJQZGOIKFHENYVU
 BMCSRFHLTDENQWAOXPYVUIKZGJ
 XPLTDAOIKFZGHENYSRUBMCQWVJ
 TDSWAYXPLVUBOIKZGJRFHENMCQ

-------------------------------------

 HGVSFUWIKPBELNACZDTR**X**MJQOY
 CPMNZQWXYIHFRLABEUOT**S**GJVDK
 BVIQHKYPNTCRMOSFEZWA**X**JGDLU
 TEQGYXPLOCKBDMAIZVRN**S**JUWFH
 SLOQXVETAMKGHIWPNYCJ**B**FZDRU
 XQYIZMJWAORPLNDVHGFC**U**KTEBS
 WATDSRFHENYVUBMCOIKZ**G**JXPLQ
 CEONJQGWTHSPYBXIZULV**K**MRAFD
 RJLXKISEFAPMYGHBQNOZ**U**TWDCV
 QWXPHKZGJTDSENYVUBML**A**OIRFC
 GOIKFHENYVUWABMCXPLT**D**SRJQZ
 LTDENQWAOXPYVUIKZGJB**M**CSRFH
 ENYSRUBMCQWVJXPLTDAO**I**KFZGH
 SWAYXPLVUBOIKZGJRFHE**N**MCQTD
```



```
flag{xsxsbugadmin}
```



### 先人工将字符串行号排序，然后才用脚本解密，脚本如下：

```python
fileone = open("file.txt", "r+")  # 手工排序行号的字符串
filetwo = open("c.txt", "w+")  # 新的文件保存结果
attr = "HCBTSXWCRQGLES"  # 密文
attrtwo = ""
num = 0
for line in fileone:
    # print(len(line))
    for i in line:
        if i != attr[num]:
            attrtwo = attrtwo + i
        else:
            # attrtwo = attrtwo + i
            attrone = line[len(attrtwo):26]+attrtwo + "\n"
            filetwo.write(attrone)
            break
    attrtwo = ""
    num = num + 1
fileone.close()
filetwo.close()

```

